Index: trunk/prototype/modules/calendar/js/calendar.codecs.js
===================================================================
--- trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 6533)
+++ trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 6996)
@@ -22,5 +22,6 @@
 	    fontColor: "fff",
 	    timezone: 'America/Sao_Paulo',
-	    weekStart: 'SUN'
+	    weekStart: 'SUN',
+	    useDesktopNotification: 0
 	};
 
@@ -31,4 +32,6 @@
     }
 }
+
+updateActivity = false;
 
 constantsParticipant = {
@@ -195,4 +198,6 @@
 	DataLayer.commit( false, false, function(){	
             Calendar.rerenderView(true);
+	    if(updateActivity)
+		refreshTaskActivity();
 	});
     }
@@ -262,5 +267,5 @@
 		user: User.me.id,	
 		calendar: {
-		    id: Calendar.calendarOf[form.signature].id,
+		    id: !!!parseInt(form.type) ? Calendar.calendarOf[form.signature].id : Calendar.groupOf[form.signature].id,
 		    name: Encoder.htmlEncode(form.name),
 		    description: Encoder.htmlEncode(form.description),
@@ -384,4 +389,87 @@
 
       
+});
+
+DataLayer.codec( "schedulable", "taskEdit", {
+
+    decoder: function( evtObj ){
+	Encoder.EncodeType = "entity";
+	
+	if( notArray = $.type(evtObj) !== "array" )
+	    evtObj = [ evtObj ];
+
+	var pref = User.preferences;
+		
+	var res = $.map(evtObj, function( form ){
+			
+	    return DataLayer.merge({
+		id: form.idTask,
+		percentage: form.percentage,
+		type: '2', 
+		status: form.taskStatus,
+		participants : $.map(form.attendee, function( attendee, i ){
+		    if(isNaN(attendee)){
+			return{
+			    id: attendee,
+			    acl: form.attendeeAcl[i],
+			    delegatedFrom: !!form.delegatedFrom[i] ? form.delegatedFrom[i] : 0,
+			    isOrganizer: (form.attendee_organizer == attendee ? 1 : 0 ),
+			    isExternal: !!parseInt(form.attendeeType[i]) ? 1 : 0,
+			    acl: form.attendeeAcl[i].replace('o', '')
+			};
+		    }else{
+			if(DataLayer.get('participant', attendee).user == User.me.id){
+			    var me = {
+				user: User.me.id,
+				status: form.status,
+				id: attendee,
+				isOrganizer: 0,
+				receiveNotification : (!!form.receiveNotification ? 1 : 0),
+				alarms: typeof(form.alarmTime) != 'undefined' ? 
+				$.map( form.alarmTime || [], function( alarmTime, i ){
+
+				    if( alarmTime === "" )
+					return( null );
+
+				    return !!form.alarmId[i] ?
+				    {
+					type: form.alarmType[i], 
+					unit: form.alarmUnit[i], 
+					time: form.alarmTime[i], 
+					id: form.alarmId[i]
+					} : 
+{
+					type: form.alarmType[i],
+					unit: form.alarmUnit[i], 
+					time: form.alarmTime[i]
+					};
+				}) : []
+			    };
+							
+			    if(form.startDate){
+				var tzId =  DataLayer.get('schedulable', form.idEvent).timezone || User.preferences.timezone,
+				formatString = pref.dateFormat + " " + pref.hourFormat;
+								
+				DataLayer.put('notification', {
+				    participant: me.id,
+				    type: 'suggestion',
+				    startTime: Date.parseExact(form.startDate + (!!form.allDay ? " 00:00": " "+$.trim(form.startHour)) , formatString ).toString('yyyy-MM-dd HH:mm:00'),
+				    endTime:  Date.parseExact(form.endDate + ( !!form.allDay ? " 00:00": " "+$.trim(form.endHour)), formatString ).toString('yyyy-MM-dd HH:mm:00'),
+				    allDay: ( !!form.allDay ? 1 : 0 ),
+				    schedulable: form.idEvent
+				});
+							
+			    }
+			    return me;
+			}else return(null);
+		    };
+		})
+	    }, (form.group != form.lastGroup? {calendar: form.group, lastCalendar: form.lastGroup} : {}))
+	});
+	return notArray ? res[0] : res;
+    },
+
+    encoder: function( evtObj ){}
+
 });
 
@@ -510,4 +598,5 @@
 		calendar: objEvent.calendar,
 		summary: objEvent.summary,
+        type: !!objEvent.type ? objEvent.type : 1,
 		description: objEvent.description,
 		timezone: objEvent.timezone,
@@ -595,4 +684,517 @@
 });
 
+DataLayer.codec( "schedulable", "task", {
+
+    decoder: function( evtObj ){
+    Encoder.EncodeType = "entity";
+    
+    if( notArray = $.type(evtObj) !== "array" )
+        evtObj = [ evtObj ];
+
+    var pref = User.preferences;
+
+    var res = $.map(evtObj, function( form ){
+    
+        var tzId =  form.timezone || Calendar.signatureOf[form.group].calendar.timezone || User.preferences.timezone,
+
+        formatString = pref.dateFormat + " " + pref.hourFormat;
+
+        return DataLayer.merge({
+        "class": form["class"],
+        startTime: Date.parseExact(form.startDate + " "+$.trim(form.startHour) , formatString ).toString(!!form.allDay ? 'yyyy-MM-dd 00:00:00' : 'yyyy-MM-dd HH:mm:00'),
+        endTime:  Date.parseExact(form.endDate + " "+$.trim(form.endHour), formatString ).toString(!!form.allDay ? 'yyyy-MM-dd 00:00:00' : 'yyyy-MM-dd HH:mm:00'),  //+ (!!form.allDay ? 86400000 : 0) ,
+        due: (form.dueDate == '' )? 0 : Date.parseExact(form.dueDate + " "+$.trim(form.dueTime) , formatString ).toString(!!form.allDay ? 'yyyy-MM-dd 00:00:00' : 'yyyy-MM-dd HH:mm:00'),
+        allDay: ( !!form.allDay ? 1 : 0 ),      
+        status: form.taskStatus,      
+        id: form.idTask,
+        location: form.location,
+        type: !!form.type ?  form.type : 2,
+        percentage: form.percentage,
+        priority: form.priority,
+        category: form.category,
+        summary: form.summary == '' ? 'Tarefa sem título' : form.summary,
+        description: form.description,
+        timezone: tzId,
+        attachments: $.map(form.attachment || [], function( attachment, i ){
+            return {
+            attachment: attachment
+            }
+        }),
+        participants: $.map( form.attendee || [], function( attendee, i ){
+
+            if( !attendee || attendee === "" )
+            return( null );
+
+            var participant = {};
+            participant.user = (attendee!= User.me.id) ? DataLayer.get('participant', attendee).user : attendee ;
+
+            if( participant.user === User.me.id ){
+            return DataLayer.merge({
+                id: attendee,
+                isOrganizer: (form.attendee_organizer == attendee ? 1 : 0 ),
+                alarms: participant.alarms = $.map( form.alarmTime || [], function( alarmTime, i ){
+                if( alarmTime === "" )
+                    return( null );
+                return !!form.alarmId[i] ? {
+                    type: form.alarmType[i], 
+                    unit: form.alarmUnit[i], 
+                    time: form.alarmTime[i], 
+                    id: form.alarmId[i]
+                    }:
+
+                    {
+                    type: form.alarmType[i],
+                    unit: form.alarmUnit[i], 
+                    time: form.alarmTime[i]
+                    };
+                }),
+                status: !!form.status ? form.status : 3
+            }, (form.delegatedFrom[i] != '0' && form.delegatedFrom[i] != '')  ? {
+                delegatedFrom: form.delegatedFrom[i]
+                } : {});
+            }else{
+                return {
+                    id: attendee,
+                    isOrganizer: (form.attendee_organizer == attendee ? 1 : 0 ),
+                    isExternal: !!parseInt(form.attendeeType[i]) ? 1 : 0
+                    };
+            };
+        })
+        }, form.lastGroup ? (( form.lastGroup == form.group ) ? {} : {calendar: form.group, lastGroup: form.lastGroup}) : {calendar: form.group});
+    });
+
+    return notArray ? res[0] : res;
+    },
+
+    encoder: function( evtObj ){
+
+    var notArray = false;
+      
+    if( notArray = $.type(evtObj) !== "array" )
+        evtObj = [ evtObj ];
+
+    var statusParticipants = {},  isAttendee = false,
+   
+    statusLabels = [ '', 'accepted', 'tentative', 'cancelled', 'unanswered', 'delegated' ],
+
+    participantInfo = {}, delegatedFrom = {}, me = DataLayer.copy( User.me );
+    
+    var delegateAttendee = {};
+    
+    for( var i = 0; i < statusLabels.length; i++ )
+        statusParticipants[ statusLabels[i] ] = 0;
+    
+    var res = $.map(evtObj, function( objEvent ){           
+            
+        if(!(typeof(objEvent) == 'object'))
+            return (null);
+
+        var limitAttendee = false;
+
+        return {
+        "class": objEvent["class"],
+        id: objEvent.id,
+        location: objEvent.location,
+        category: objEvent.category,
+        taskStatus: objEvent.status,
+        groups: Calendar.groups,
+        group: objEvent.group ? objEvent.group : objEvent.calendar,
+        summary: objEvent.summary,
+        type: !!objEvent.type ? objEvent.type : 2,
+        description: objEvent.description,
+        timezone: objEvent.timezone,
+        timezones: Timezone.timezones,
+        percentage: (objEvent.percentage) ? objEvent.percentage : '0',
+        priority: objEvent.priority,
+        startDate: new Date( parseInt(objEvent.startTime) ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+        startHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(objEvent.startTime)), objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'startTime'), User.preferences.hourFormat),
+        endDate: new Date( parseInt(objEvent.endTime) - (!!parseInt(objEvent.allDay) ? 86400000 : 0)  ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+        endHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date(parseInt(objEvent.endTime)),  objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'endTime'), User.preferences.hourFormat),
+        dueDate: (!objEvent.due || objEvent.due == '' || objEvent.due == '0') ? '' : new Date( parseInt(objEvent.due) ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+        dueTime: (!objEvent.due || objEvent.due == '' || objEvent.due == '0') ? '' : dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(objEvent.due)), objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'startTime'), User.preferences.hourFormat),
+        allDay: !!parseInt( objEvent.allDay ),
+	    historic: !!objEvent.historic ? decodeHistoric(objEvent) : [] ,
+        attachments: $.map(objEvent.attachments || [], function( attachment, i ){
+            var attach = DataLayer.get('schedulableToAttachment', attachment, false);
+            //TODO - Verificar na API retorno de id sobre os conceitos em que s?o utilizados tabelas de liga??o
+            if(!attach.name) return(null); 
+            
+            var ext = attach.name.split('.');
+            attach.name = attach.name.length < 10 ?  attach.name : ( ext.length == 1 ? attach.name.substr(0, 10) : (attach.name.substr(0, 6) + '.' +  ext[ext.length -1]));
+            attach.size = formatBytes(attach.size);
+            return attach;
+        }),                     
+        attendee: $.map(objEvent.participants || [], function( participant, i ){                        
+
+            if(delegateAttendee[participant])
+                return(null);
+
+            var attend = DataLayer.get('participant', (participant.id || participant));
+            attend.user = DataLayer.get('user', attend.user);
+
+            statusParticipants[ statusLabels[attend.status] ]++;    
+
+            if(attend.user.mail == User.me.mail)
+                isAttendee = true;
+
+            if( attend.user.id ===  me.id ){
+                participantInfo.user = {
+                    id: attend.id,
+                    status : attend.status,
+                    delegatedFrom: attend.delegatedFrom || '0',
+                    acl: attend.acl,
+                    receiveNotification : attend.receiveNotification,
+                    alarms : $.map(attend.alarms || [], function( alarm ){
+                    var alarm = DataLayer.get('alarm', alarm);
+                    return (alarm == "" ? (null) : alarm);
+                    })
+                };
+                me = attend;
+                return(null);
+            };
+
+            var person = {
+                id: attend.id,
+                name: attend.user.name != 'false' ? attend.user.name : '',
+                mail: attend.user.mail,
+                status : attend.status,
+                isExternal: attend.isExternal,
+                acl: attend.acl,
+                delegatedFrom: attend.delegatedFrom
+            };
+
+            if(!!parseInt(attend.delegatedFrom)){
+                delegatedFrom[attend.delegatedFrom] = DataLayer.copy(person);
+                return(null);
+            }
+
+            if( !!parseInt(attend.isOrganizer)){
+                participantInfo.organizer = DataLayer.copy(person);
+                return(null);
+            };                  
+
+            return (person);
+        }),
+        organizer: participantInfo.organizer || me,
+	isOrganizer: (participantInfo.organizer || me).id == me.id,
+        alarms: !!participantInfo.user ? participantInfo.user.alarms : [],
+        status: !!participantInfo.user ? participantInfo.user.status : 1,
+        isAttendee: isAttendee,
+        me: me,
+        delegatedFrom: delegatedFrom,
+        statusParticipants: (objEvent.sizeAttendees != "") ? objEvent.statusAttendees : statusParticipants,
+        sizeAttendeeLimit: (objEvent.sizeAttendees != "") ? objEvent.sizeAttendees : false
+        };
+    });
+    return (notArray ? res[0] : res);
+    }
+});
+
+function decodeHistoric ( evt ) {
+    var historic = evt.historic;
+    var decoded = [];
+    var attributeDecoded = {
+        'startTime': 'Data de inicio',
+        'endTime' : 'Data de fim',
+        'summary' : 'Título',
+        'description': 'Descrição',
+        'status': 'Status',
+        'percentage': 'Porcentagem',
+        'priority': 'Priorudade',
+        'due' : 'Previsão de término'
+    }
+    
+    var statusDecoded = {
+	1: 'Sem ações',
+	2: 'Em processo',
+	3: 'Finalzada',
+	4: 'Cancelada',
+    }
+
+    var decodeDate = function(time){
+        return new Date( parseInt( time) ).setTimezoneOffset( Timezone.timezone( evt.timezone ) ).toString( User.preferences.dateFormat+' - '+User.preferences.hourFormat );
+    };
+
+    var decodeItem = function(historic){
+        switch(historic.attribute){
+            case 'startTime':
+            case 'endTime' :
+            case 'due':
+                return {
+                    user :$.type(historic.user) == 'object' ? historic.user : DataLayer.get('user', historic.user),
+                    attribute : attributeDecoded[historic.attribute],
+                    beforeValue : decodeDate(historic.beforeValue),
+                    afterValue : decodeDate(historic.afterValue),
+                    time: decodeDate(historic.time)
+                }
+            break;
+            case 'participant':
+                return{
+                    user :$.type(historic.user) == 'object' ? historic.user : DataLayer.get('user', historic.user),
+                    attribute : historic.beforeValue == '' ? ('Novo participante') : ('Rem. participante'),
+                    beforeValue : historic.beforeValue == '' ? '' : historic.beforeValue.mail,
+                    afterValue : historic.afterValue == '' ? '' : historic.afterValue.mail,
+                    time: decodeDate(historic.time)
+                }
+            break;
+            case 'attachment':
+                return{
+                    user : $.type(historic.user) == 'object' ? historic.user : DataLayer.get('user', historic.user),
+                    attribute : historic.beforeValue == '' ? ('Novo anexo') : ('Rem. anexo'),
+                    beforeValue : historic.beforeValue,
+                    afterValue : historic.afterValue,
+                    time: decodeDate(historic.time)
+                }
+            case 'percentage':
+                    return{
+                    user :$.type(historic.user) == 'object' ? historic.user : DataLayer.get('user', historic.user),
+                    attribute :attributeDecoded[historic.attribute],
+                    beforeValue : historic.beforeValue+' %',
+                    afterValue : historic.afterValue+' %',
+                    time: decodeDate(historic.time)
+                }
+	    case 'status':
+                    return{
+                    user :$.type(historic.user) == 'object' ? historic.user : DataLayer.get('user', historic.user),
+                    attribute :attributeDecoded[historic.attribute],
+                    beforeValue : statusDecoded[historic.beforeValue],
+                    afterValue : statusDecoded[historic.afterValue],
+                    time: decodeDate(historic.time)
+                }
+            break;
+            default:
+                return {
+                    user : $.type(historic.user) == 'object' ? historic.user : DataLayer.get('user', historic.user),
+                    attribute : attributeDecoded[historic.attribute],
+                    beforeValue : historic.beforeValue,
+                    afterValue : historic.afterValue,
+                    time: decodeDate(historic.time)
+                }
+            break;
+
+        }
+    }
+
+    for(var i = 0; i < historic.length; i++)
+        decoded.push(decodeItem(historic[i]));
+
+    return decoded;
+
+}
+
+DataLayer.codec( "schedulable", "taskSearch", {
+
+    decoder: function( evtObj ){
+
+    },
+
+    encoder: function( evtObj ){
+
+    var notArray = false;
+      
+    if( notArray = $.type(evtObj) !== "array" )
+        evtObj = [ evtObj ];
+
+    var res = $.map(evtObj, function( objEvent ){           
+            
+        if(!(typeof(objEvent) == 'object'))
+            return (null);
+
+        return {
+            id: objEvent.id,
+            description: !!objEvent.summary ? objEvent.summary : objEvent.description,
+            startDate: new Date( parseInt(objEvent.startTime) ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+            startHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(objEvent.startTime)), objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'startTime'), User.preferences.hourFormat),
+            endDate: new Date( parseInt(objEvent.endTime) - (!!parseInt(objEvent.allDay) ? 86400000 : 0)  ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+            endHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date(parseInt(objEvent.endTime)),  objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'endTime'), User.preferences.hourFormat),
+            dueDate: (!objEvent.due || objEvent.due == '' || objEvent.due == '0') ? '' : new Date( parseInt(objEvent.due) ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+            dueTime: (!objEvent.due || objEvent.due == '' || objEvent.due == '0') ? '' : dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(objEvent.due)), objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'startTime'), User.preferences.hourFormat),
+            allDay: !!parseInt( objEvent.allDay ),
+            percentage: (objEvent.percentage) ? objEvent.percentage : '0',
+			status: objEvent.status
+        }
+    });
+    return (notArray ? res[0] : res);
+    }
+});
+
+DataLayer.codec( "schedulable", "activity", {
+
+    decoder: function( evtObj ){
+    Encoder.EncodeType = "entity";
+    
+    if( notArray = $.type(evtObj) !== "array" )
+        evtObj = [ evtObj ];
+
+    var pref = User.preferences;
+
+    var res = $.map(evtObj, function( form ){
+    
+        var tzId =  form.timezone || Calendar.signatureOf[form.group].calendar.timezone || User.preferences.timezone,
+        formatString = pref.dateFormat + " " + pref.hourFormat;
+
+	var decodeParticipants = function(attend){
+	    return [DataLayer.merge(
+		{  
+		    user: User.me.id, 
+		    isOrganizer: 1,
+		    acl: 'row',
+		    alarms: $.map( form.alarmTime || [], function( alarmTime, i ){
+			if( alarmTime === "" )
+			    return( null );
+			return !!form.alarmId[i] ? {
+			    type: form.alarmType[i], 
+			    unit: form.alarmUnit[i], 
+			    time: form.alarmTime[i], 
+			    id: form.alarmId[i]
+			    }:
+
+			    {
+			    type: form.alarmType[i],
+			    unit: form.alarmUnit[i], 
+			    time: form.alarmTime[i]
+			    };
+		    })
+		}, attend != '0' ? {id: attend} : {})];
+	};
+
+        return DataLayer.merge({
+        "class": form["class"],
+        startTime: Date.parseExact(form.startDate + " "+$.trim(form.startHour) , formatString ).toString(!!form.allDay ? 'yyyy-MM-dd 00:00:00' : 'yyyy-MM-dd HH:mm:00'),
+        endTime:  Date.parseExact(form.endDate + " "+$.trim(form.endHour), formatString ).toString(!!form.allDay ? 'yyyy-MM-dd 00:00:00' : 'yyyy-MM-dd HH:mm:00'),  //+ (!!form.allDay ? 86400000 : 0) ,
+        due: (form.dueDate == '' )? 0 : Date.parseExact(form.dueDate + " "+$.trim(form.dueHour) , formatString ).toString(!!form.allDay ? 'yyyy-MM-dd 00:00:00' : 'yyyy-MM-dd HH:mm:00'),
+        allDay: ( !!form.allDay ? 1 : 0 ),      
+        status: form.activityStatus,      
+        id: form.idActivity,
+        type: !!form.type ?  form.type : 2,
+        percentage: form.percentage,
+        priority: form.priority,
+        category: form.category,
+        summary: form.summary == '' ? 'Atividade sem título' : form.summary,
+        description: form.description,
+        timezone: tzId,
+        attachments: $.map(form.attachment || [], function( attachment, i ){
+            return {
+            attachment: attachment
+            }
+        }),
+        participants: decodeParticipants(form.idAttendee),
+        taskToActivity:$.map( form.idtask || [], function( task, i ){
+
+            return DataLayer.merge({
+                task: task,
+                owner: User.me.id
+            }, form.idTaskToActivity[i] != '' ? {id: form.idTaskToActivity[i]} : {});
+
+        })
+        }, form.lastGroup ? (( form.lastGroup == form.group ) ? {} : {calendar: form.group, lastGroup: form.lastGroup}) : {calendar: form.group});
+    });
+
+    return notArray ? res[0] : res;
+    },
+
+    encoder: function( evtObj ){
+
+    var notArray = false;
+      
+    if( notArray = $.type(evtObj) !== "array" )
+        evtObj = [ evtObj ];
+    
+    var res = $.map(evtObj, function( objEvent ){           
+            
+        if(!(typeof(objEvent) == 'object'))
+            return (null);
+	
+	var historic = [];
+
+        var decodeTasks = function(obj){
+
+            var tasks = {}, task = {};
+
+            for(var i =0; i < obj.taskToActivity.length; i++){
+
+                taskToActivity = DataLayer.get('taskToActivity', obj.taskToActivity[i]); 
+                task = taskToActivity.task;
+
+                if($.type(task) != 'object')
+                    task = DataLayer.get('schedulable', task);
+
+                tasks[task.id] = {
+                    taskToActivity: taskToActivity.id,
+                    allDay: !!parseInt(task.allDay),
+                    dueDate: (!task.due || task.due == '' || task.due == '0') ? '' : new Date( parseInt(task.due) ).setTimezoneOffset( Timezone.timezone( task.timezone ) ).toString( User.preferences.dateFormat ),
+                    dueTime: (!task.due || task.due == '' || task.due == '0') ? '' : dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(task.due)), task.timezone, obj.calendar, obj.DayLigth, 'startTime'), User.preferences.hourFormat),
+                    startDate: new Date( parseInt(task.startTime) ).setTimezoneOffset( Timezone.timezone( task.timezone ) ).toString( User.preferences.dateFormat ),
+                    startHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(task.startTime)), task.timezone, task.calendar, obj.DayLigth, 'startTime'), User.preferences.hourFormat),
+                    endDate: new Date( parseInt(task.endTime) - (!!parseInt(task.allDay) ? 86400000 : 0)  ).setTimezoneOffset( Timezone.timezone( task.timezone ) ).toString( User.preferences.dateFormat ),
+                    endHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date(parseInt(task.endTime)),  task.timezone, obj.calendar, obj.DayLigth, 'endTime'), User.preferences.hourFormat),
+		    status: task.status,
+		    percentage: task.percentage
+                }
+
+                tasks[task.id].description = tasks[task.id].startDate + ' - ' + (!!task.summary ? task.summary : task.description);
+
+		historic.push({'task': (!!task.summary ? task.summary : task.description) , 'historic': decodeHistoric(task)});
+            }
+
+            tasks.length = obj.taskToActivity.length;
+            return tasks;
+
+        };
+
+        return {
+        "class": objEvent["class"],
+        id: objEvent.id,
+        location: objEvent.location,
+        category: objEvent.category,
+        activityStatus: objEvent.status,
+        groups: Calendar.groups,
+        group: objEvent.group ? objEvent.group : objEvent.calendar,
+        summary: objEvent.summary,
+        type: !!objEvent.type ? objEvent.type : 2,
+        description: objEvent.description,
+        timezone: objEvent.timezone,
+        timezones: Timezone.timezones,
+        percentage: (objEvent.percentage) ? objEvent.percentage : '0',
+        priority: objEvent.priority,
+        startDate: new Date( parseInt(objEvent.startTime) ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+        startHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(objEvent.startTime)), objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'startTime'), User.preferences.hourFormat),
+        endDate: new Date( parseInt(objEvent.endTime) - (!!parseInt(objEvent.allDay) ? 86400000 : 0)  ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+        endHour: dateCalendar.formatDate(Timezone.getDateEvent(new Date(parseInt(objEvent.endTime)),  objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'endTime'), User.preferences.hourFormat),
+        dueDate: (!objEvent.due || objEvent.due == '' || objEvent.due == '0') ? '' : new Date( parseInt(objEvent.due) ).setTimezoneOffset( Timezone.timezone( objEvent.timezone ) ).toString( User.preferences.dateFormat ),
+        dueTime: (!objEvent.due || objEvent.due == '' || objEvent.due == '0') ? '' : dateCalendar.formatDate(Timezone.getDateEvent(new Date( parseInt(objEvent.due)), objEvent.timezone, objEvent.calendar, objEvent.DayLigth, 'startTime'), User.preferences.hourFormat),
+        allDay: !!parseInt( objEvent.allDay ),
+        historic: historic,
+        tasks: objEvent.taskToActivity ? decodeTasks(objEvent) : {},
+        attachments: $.map(objEvent.attachments || [], function( attachment, i ){
+            var attach = DataLayer.get('schedulableToAttachment', attachment, false);
+            //TODO - Verificar na API retorno de id sobre os conceitos em que s?o utilizados tabelas de liga??o
+            if(!attach.name) return(null); 
+            
+            var ext = attach.name.split('.');
+            attach.name = attach.name.length < 10 ?  attach.name : ( ext.length == 1 ? attach.name.substr(0, 10) : (attach.name.substr(0, 6) + '.' +  ext[ext.length -1]));
+            attach.size = formatBytes(attach.size);
+            return attach;
+        }),
+        me : User.me,
+        attendee: $.map(objEvent.participants || [], function( participant, i ){                        
+
+            var attend = DataLayer.get('participant', (participant.id || participant));
+            attend.user = DataLayer.get('user', attend.user);
+
+            return {
+                id: attend.id,
+                alarms : $.map(attend.alarms || [], function( alarm ){
+                    var alarm = DataLayer.get('alarm', alarm);
+                    return (alarm == "" ? (null) : alarm);
+                })
+            };
+        })
+
+        };
+    });
+    return (notArray ? res[0] : res);
+    }
+});
 
 function decodeOwnerCalendar(calendar){
@@ -727,6 +1329,7 @@
 		id: form.idEvent,
 		location: form.location,
+		type: 1,
 		category: form.category,
-		summary: form.summary,
+		summary: form.summary == '' ? 'Evento sem título' : form.summary,
 		description: form.description,
 		timezone: tzId,
@@ -800,6 +1403,9 @@
 
 	var pref = User.preferences;
-
-	var res =  DataLayer.encode('schedulable:preview', evtObj);
+    var res = [];
+
+    for(var i = 0; i < evtObj.length; i++){
+	   res.push(DataLayer.encode('schedulable:' + (evtObj[i].type == '1' ?  'preview' : ( !!evtObj[i].taskToActivity ? 'activity': 'task')) , evtObj[i]));
+    }
 
 	if( !notArray ){
@@ -814,4 +1420,6 @@
 
 	    for (var i=0; i < res.length; i++) {
+
+        res[i].type = (res[i].type == '2' && !!res[i].tasks) ? '3' : res[i].type;
 			  
 		var startDate = Date.parseExact( res[i]['startDate'], User.preferences.dateFormat );
@@ -836,9 +1444,7 @@
 			'endDate': new Date( occurrences[ii] + duration ).toString( User.preferences.dateFormat )
 			} );
-				  
-				  
-				  
-				  
-		    res2.repeat = typeRepeat[res[i].repeat.frequency];
+
+		    if(res[i].repeat)
+                res2.repeat = typeRepeat[res[i].repeat.frequency];
 				  
 		    while (counter.compareTo( currentDate ) == 0) {
